--CONTA QUANTIDADE ALTERACOES SALARIO -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
--Tabelas: RHALTERACOESSALARIO, RHALTERACOESSALARIO
--Leiaute 6 - Alterao de Salario
--V1 - 18/10/2023
--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

SELECT COUNT(1) TOTAL
               FROM RHALTERACOESSALARIO
               JOIN RHCONTRATOS
                 ON RHCONTRATOS.CONTRATO = RHALTERACOESSALARIO.CONTRATO
                AND RHCONTRATOS.UNIDADE  = RHALTERACOESSALARIO.UNIDADE
             UNION ALL
             SELECT COUNT(1) TOTAL
               FROM RHCONTRATOS;


--GERA LEIAUTE ALTERACOES SALARIO -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
--Tabelas: RHALTERACOESSALARIO, RHALTERACOESSALARIO
--Leiaute 6 - Alterao de Salario
--V2 - 08/11/2023 - Incrementa o nro ocorrencia quando ocorrem duas alteraes na mesma data
--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

                 
SELECT
    empresa|| '_'||contrato                                                     AS "NrVinculo",
    -------------------------------------------------------------------------------------------------------
    to_char(nvl(dataultimoreajuste, dataadmissao),'DD/MM/YYYY')                 AS "DtAlteracao",
    -------------------------------------------------------------------------------------------------------
    ROW_NUMBER()
        OVER(PARTITION BY 
                    empresa|| '_'|| contrato,
                    to_char(nvl(dataultimoreajuste, dataadmissao),'DD/MM/YYYY')
             ORDER BY 1,2
        )                                                                       AS "Nro_Ocorrencia",
    -------------------------------------------------------------------------------------------------------    
    CASE
        WHEN dataultimoreajuste IS NULL THEN
            '1'
        ELSE
            '22'
    END                                                                         AS "TipoAlteracao",
    -------------------------------------------------------------------------------------------------------    
    salariomes                                                                  AS "Salario",
    -------------------------------------------------------------------------------------------------------    
    decode(tiposalario, 
                    '1', 'MENSAL', 
                    '2', 'QUINZENAL',
                    '3', 'SEMANAL', 
                    '4', 'DIARIO', 
                    '5', 'MENSAL_SALARIO_HORA', 
                    '6', 'TAREFA', 
                         'MENSAL')                                              AS "TipoSalario",
    -------------------------------------------------------------------------------------------------------    
    'Gerado tb RHCONTRATOS pois nao haviam dados na tb HALTERACOESSALARIO'      AS "Observacao"
FROM
    (
        SELECT DISTINCT
            empresa,
            contrato,
            dataultimoreajuste,
            dataadmissao,
            salariomes,
            tiposalario
        FROM
            rhcontratos
        ORDER BY
            empresa|| '_'||contrato,
            to_char(nvl(dataultimoreajuste, dataadmissao),'DD/MM/YYYY'),
            salariomes
    );
 

/*
--GERA LEIAUTE ALTERACOES SALARIO -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
--Tabelas: RHALTERACOESSALARIO, RHALTERACOESSALARIO
--Leiaute 6 - Alterao de Salario
--V1 - 18/10/2023 - 
--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

SELECT DISTINCT
    nvl(dataultimoreajuste, dataadmissao),
    empresa|| '_'|| contrato                                                    AS "Nr Vinculo",
    to_char(nvl(dataultimoreajuste, dataadmissao),'DD/MM/YYYY')                 AS "Dt. Alterao",
    '1'                                                                         AS "Numero Ocorrencia",
    CASE
        WHEN dataultimoreajuste IS NULL THEN
            '1'
        ELSE
            '22'
    END                                                                         AS "Tipo Alterao",
    salariomes                                                                  AS "Salrio",
    decode(tiposalario, '1', 'MENSAL', 
                        '2', 'QUINZENAL',
                        '3', 'SEMANAL', 
                        '4', 'DIARIO', 
                        '5', 'MENSAL_SALARIO_HORA', 
                        '6', 'TAREFA', 
                             'MENSAL')                                          AS "Tipo Salrio",
    'Gerado tabela de RHCONTRATOS pois nao haviam dados na tabela HALTERACOESSALARIO'                                                         AS "Observao"
FROM
    rhcontratos   
     --(causarescisaofolha<>6 or causarescisaofolha is null )
order by empresa|| '_'|| contrato;

*/

 --=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

/*            NO EXISTEM REGISTROS NESSA TABELA
             SELECT RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, RHALTERACOESSALARIO.DATAHORA, 
                  DECODE(RHALTERACOESSALARIO.TIPOSALARIO, '1', 'MENSAL', '2', 'QUINZENAL', '3', 'SEMANAL', '4', 'DIARIO', '5', 'HORA', '6', 'TAREFA', 'MENSAL') TIPOSALARIO,
                  RHALTERACOESSALARIO.SALARIOCONTRATUAL, 
                  DECODE(RHALTERACOESSALARIO.MOTIVOALTSALARIO,
                         '01', '4',
                         '02', '3',
                         '03', '7',
                         '04', '7',
                         '05', '12',
                         '06', '12',
                         '07', '2',
                         '08', '7',
                         '09', '14',
                         '10', '7',
                         '11', '22',
                         '12', '1',
                         '13', '8',
                         '99', '22') MOTIVOALTSALARIO
             FROM RHALTERACOESSALARIO
             JOIN RHCONTRATOS
               ON RHCONTRATOS.CONTRATO = RHALTERACOESSALARIO.CONTRATO
              AND RHCONTRATOS.UNIDADE  = RHALTERACOESSALARIO.UNIDADE;
              
              */
              
              
SELECT    empresa||'_'||contrato,
          to_char(nvl(dataultimoreajuste, dataadmissao),                  'DD/MM/YYYY'),          
          row_number()  
    
    OVER(PARTITION BY empresa                       || '_'                      || contrato,
          to_char(nvl(dataultimoreajuste, dataadmissao),                  'DD/MM/YYYY')
          order by 1,2
        ) sequencial , salariomes
FROM
    (SELECT DISTINCT
    empresa,
    contrato,
    dataultimoreajuste,
    dataadmissao,
    salariomes,
    empresa|| '_'|| contrato                                                    AS "NrVinculo",
    to_char(nvl(dataultimoreajuste, dataadmissao),'DD/MM/YYYY')                 AS "DtAlteracao",
    '1'                                                                         AS "NumeroOcorrencia",
    CASE
        WHEN dataultimoreajuste IS NULL THEN
            '1'
        ELSE
            '22'
    END                                                                         AS "TipoAlteracao",
    salariomes                                                                  AS "Salario",
    decode(tiposalario, '1', 'MENSAL', 
                        '2', 'QUINZENAL',
                        '3', 'SEMANAL', 
                        '4', 'DIARIO', 
                        '5', 'MENSAL_SALARIO_HORA', 
                        '6', 'TAREFA', 
                             'MENSAL')                                          AS "TipoSalario",
    'Gerado tabela de RHCONTRATOS pois nao haviam dados na tabela HALTERACOESSALARIO'                                                         AS "Observacao"
FROM
    rhcontratos   
     --(causarescisaofolha<>6 or causarescisaofolha is null )
order by empresa|| '_'|| contrato, to_char(nvl(dataultimoreajuste, dataadmissao),'DD/MM/YYYY')  ,salariomes);
 --where (causarescisaofo;lha<>6 or causarescisaofolha is null )

   
   
    
    
    
    
    
    /* Select t.*,
       row_number() over (partition by id, cat, seqnum - seqnum_c order by date) as row_num
from (select t.*,
             row_number() over (partition by id order by date) as seqnum,
             row_number() over (partition by id, cat order by date) as seqnum_c
      from t
     ) t; 
     */