<?php

namespace HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros;

use HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros\Registro0000;

class RegistroK150 extends Registro0000 {

    private $_cnpjCei;
    private $_dtIncAlt;
    private $_cobRub;
    private $_descRub;

    public function geraRegistroK150(){
        $this->_geraRegistro(self::REGISTRO_K150);
    }

    private function _geraRegistro($tpRegistro){
        // Ordem 1
        $this->atribuiDadoManad($tpRegistro);
        // Ordem 2
        $this->atribuiDadoManad($this->_cnpjCei);
        // Ordem 3
        $this->atribuiDadoManad($this->_dtIncAlt);
        // Ordem 4
        $this->atribuiDadoManad($this->_cobRub);
        // Ordem 5
        $this->atribuiDadoManad($this->_descRub, true);
    }
    
    public function setCnpjCei($cnpjCei){
        $this->_cnpjCei = $cnpjCei;
    }
    public function setDtIncAlt($dtIncAlt){
        $this->_dtIncAlt = $dtIncAlt;
    }
    public function setCobRub($cobRub){
        $this->_cobRub = $cobRub;
    }
    public function setDescRub($descRub){
        $this->_descRub = $descRub;
    }
}